import pygame, sys
from pygame.locals import *

class MessageBox:
    """Class to show a message box to the user.
    Waits for user to press Enter before returning"""
    def __init__(self, msgs, font, screen, click=True):
        self.surf = pygame.surface.Surface((400, 240))
        self.msgs = []
        self.fntH = font.get_height()
        for msg in msgs:
            self.msgs.append(font.render(msg, True, (255, 255, 255)))
        w = self.surf.get_width()
        h = self.surf.get_height()
        x = 320 - w/2 
        y = 240 - h/2
        self.surf.fill((0,0,0))
        self.surf.set_alpha(200)
        screen.blit(self.surf, (x, y))
        x = x + 20
        y = y + 40
        for i in xrange(len(self.msgs)):
            w = self.msgs[i].get_width()
            screen.blit(self.msgs[i], (320-w/2, y + self.fntH*i))

        self.click = click
        if self.click:            
            tmp = font.render("Press [Enter / LClick] to continue.", True, (0, 255, 0))
        else:
            tmp = font.render("Press [Enter] to continue.", True, (0, 255, 0))
        screen.blit(tmp, (320-tmp.get_width()/2,240+h/2-(2*self.fntH)))
        tmp = font.render("Press [Esc] to exit game.", True, (0, 255, 0))
        screen.blit( tmp, (320-tmp.get_width()/2,240+h/2-self.fntH))
        #font.set_bold(True)
        tmp = font.render("Robo Minions", True, (0, 255, 0))
        #font.set_bold(False)
        screen.blit(tmp, (320-tmp.get_width()/2, 240-h/2))
        pygame.display.flip()                

    def show(self):
        done = False
        while not(done):
            #pygame.mouse.set_pos(self.pos)
            for event in pygame.event.get():
                if event.type == MOUSEBUTTONDOWN:
                    if self.click:
                        done = True
                if event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        pygame.font.quit()
                        pygame.quit()
                        sys.exit(0)
                    elif event.key == K_RETURN:
                        done = True

